"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var registry_1 = require("../modules/registry");
var readline = __importStar(require("readline"));
var logging_1 = require("../utilities/logging");
var path = __importStar(require("path"));
var Command = /** @class */ (function () {
    function Command() {
    }
    Command.prototype.execute = function (options) {
        var e_1, _a;
        return __awaiter(this, void 0, void 0, function () {
            var directory, registry, error_1, start, registry_2, registry_2_1, data, meta, model, content, total, speed, remained, e_1_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!options.paths) {
                            throw new Error("Cannot find paths to process, internal error");
                        }
                        if (options.paths.length === 0) {
                            throw new Error("Target directory is not specified. Please enter directory path for meta files.");
                        }
                        if (options.paths.length > 1) {
                            console.warn("Found more than one path, the first will be used (" + options.paths + ")");
                        }
                        directory = options.paths[0];
                        if (!options.registry) {
                            throw new Error("You must specify registry to backup using the option --registry");
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, registry_1.RegistryFactory.createRegistry(options.registry)];
                    case 2:
                        registry = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        throw new Error("Cannot load registry \"" + options.registry + "\", error: " + error_1.message);
                    case 4:
                        console.log("Starting loading data..");
                        start = Date.now();
                        _b.label = 5;
                    case 5:
                        _b.trys.push([5, 10, 11, 16]);
                        registry_2 = __asyncValues(registry);
                        _b.label = 6;
                    case 6: return [4 /*yield*/, registry_2.next()];
                    case 7:
                        if (!(registry_2_1 = _b.sent(), !registry_2_1.done)) return [3 /*break*/, 9];
                        data = registry_2_1.value;
                        try {
                            for (meta in data) {
                                model = meta;
                                content = void 0;
                                try {
                                    content = JSON.stringify(model, null, 2);
                                }
                                catch (_c) {
                                    // In case of JSON error, we should continue parsing, otherwise it will be a blocking issue
                                    continue;
                                }
                                fs.writeFileSync(path.resolve(directory, model.name.replace(/[\/?%*:|"<>]+/g, '_') + ".json"), content);
                            }
                        }
                        catch (error) {
                            throw new Error("Cannot data into file, error: " + error.message);
                        }
                        total = void 0;
                        speed = registry.done / (Date.now() - start) * 1000;
                        if (registry.total > 0) {
                            remained = (registry.total - registry.done) / speed;
                            total = logging_1.toTerminalString(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          Done ", "% (", " of ", " packages done)\n          Remained about ", " min\n          Current average speed is ", " objects per second\n        "], ["\n          Done ", "% (", " of ", " packages done)\n          Remained about ", " min\n          Current average speed is ", " objects per second\n        "])), (registry.done / registry.total).toFixed(3), registry.done, registry.total, (remained / 60).toFixed(2), speed.toFixed(3));
                        }
                        else {
                            total = logging_1.toTerminalString(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          ", " objects ready\n          Current average speed is ", " objects per second\n          This loader does not provide information about total loading progress\n        "], ["\n          ", " objects ready\n          Current average speed is ", " objects per second\n          This loader does not provide information about total loading progress\n        "])), registry.done, speed.toFixed(3));
                        }
                        readline.cursorTo(process.stdout, 0, 0);
                        readline.clearScreenDown(process.stdout);
                        process.stdout.write(logging_1.toTerminalString(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n        ", "\n        \n        Current data holder name: \n        ", "\n        \n        ", "\n      "], ["\n        ", "\n        \n        Current data holder name: \n        ", "\n        \n        ", "\n      "])), total, registry.name, registry.note));
                        _b.label = 8;
                    case 8: return [3 /*break*/, 6];
                    case 9: return [3 /*break*/, 16];
                    case 10:
                        e_1_1 = _b.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 16];
                    case 11:
                        _b.trys.push([11, , 14, 15]);
                        if (!(registry_2_1 && !registry_2_1.done && (_a = registry_2.return))) return [3 /*break*/, 13];
                        return [4 /*yield*/, _a.call(registry_2)];
                    case 12:
                        _b.sent();
                        _b.label = 13;
                    case 13: return [3 /*break*/, 15];
                    case 14:
                        if (e_1) throw e_1.error;
                        return [7 /*endfinally*/];
                    case 15: return [7 /*endfinally*/];
                    case 16: return [2 /*return*/];
                }
            });
        });
    };
    return Command;
}());
exports.Command = Command;
var templateObject_1, templateObject_2, templateObject_3;
