"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var optimist_1 = require("optimist");
var logging_1 = require("../../utilities/logging");
var networking_1 = require("../networking");
var child_process_1 = require("child_process");
var glob_promise_1 = require("glob-promise");
var path = __importStar(require("path"));
// Packages list (array with strings, names)
var packages = require('all-the-package-names/names.json');
var maxThreads = 5000;
var minThreads = 1;
var RegistryManager = /** @class */ (function () {
    function RegistryManager() {
        this.name = 'NPM (Node Package Manager)';
        this.done = 0;
        this.loader = new PackageSearchingLoader();
        this.threads = 3;
        // Override threads count (CLI option)
        if (optimist_1.argv.hasOwnProperty('threads')) {
            if (!isFinite(optimist_1.argv.threads)) {
                throw new Error("Threads value " + optimist_1.argv.threads + " is not an integer, please enter correct number between " + minThreads + " and " + maxThreads);
            }
            var num = parseInt(optimist_1.argv.threads);
            if (num < minThreads || num > maxThreads) {
                throw new Error("Threads number " + num + " must be more than " + minThreads + " and not more than " + maxThreads);
            }
            this.threads = num;
        }
        // Change loader in case if you need all packages (it works very slow)
        if (optimist_1.argv.hasOwnProperty('npm-force-package-api')) {
            this.loader = new PackageSingleLoader();
        }
        // If loader has total value initially, get it to show provide correct data instantly
        if (typeof this.loader.total === 'number') {
            this.total = this.loader.total;
        }
        this.updateNote();
    }
    RegistryManager.prototype.updateNote = function () {
        this.note = logging_1.toTerminalString(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n      NPM gonna love us for these requests in ", " ", "threads =)\n    \n      Current NPM loader name: \n      ", "\n      \n      ", "\n    "], ["\n      NPM gonna love us for these requests in ", " ", "threads =)\n    \n      Current NPM loader name: \n      ", "\n      \n      ", "\n    "])), this.threads, this.threads > 200 ? 'o_O! ' : '', this.loader.name, this.loader.note);
    };
    RegistryManager.prototype.download = function (_a) {
        var directory = _a.directory, data = _a.data, _b = _a.override, override = _b === void 0 ? true : _b;
        return __awaiter(this, void 0, void 0, function () {
            var packages, promises, _loop_1, data_1, data_1_1, meta, e_1_1;
            var e_1, _c;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        process.chdir(directory);
                        packages = data;
                        if (!!override) return [3 /*break*/, 8];
                        promises = [];
                        _loop_1 = function (meta) {
                            var _a, _b;
                            return __generator(this, function (_c) {
                                switch (_c.label) {
                                    case 0:
                                        promises.push(new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                                            var files;
                                            return __generator(this, function (_a) {
                                                switch (_a.label) {
                                                    case 0: return [4 /*yield*/, glob_promise_1.promise(path.join(directory, meta.name) + '*')];
                                                    case 1:
                                                        files = _a.sent();
                                                        if (files.length > 0) {
                                                            resolve(null);
                                                            return [2 /*return*/];
                                                        }
                                                        resolve(meta);
                                                        return [2 /*return*/];
                                                }
                                            });
                                        }); }));
                                        _b = (_a = _).flatten;
                                        return [4 /*yield*/, Promise.all(promises)];
                                    case 1:
                                        packages = _b.apply(_a, [_c.sent()]).filter(function (meta) { return meta !== null; });
                                        return [2 /*return*/];
                                }
                            });
                        };
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 6, 7, 8]);
                        data_1 = __values(data), data_1_1 = data_1.next();
                        _d.label = 2;
                    case 2:
                        if (!!data_1_1.done) return [3 /*break*/, 5];
                        meta = data_1_1.value;
                        return [5 /*yield**/, _loop_1(meta)];
                    case 3:
                        _d.sent();
                        _d.label = 4;
                    case 4:
                        data_1_1 = data_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_1_1 = _d.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (data_1_1 && !data_1_1.done && (_c = data_1.return)) _c.call(data_1);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 8: return [4 /*yield*/, new Promise(function (resolve, reject) {
                            var instance = child_process_1.spawn('npm', __spread(['pack'], packages.map(function (meta) { return meta.name; })), {
                                stdio: 'ignore'
                            });
                            instance.on('error', function (data) {
                                reject(new Error("Command failed, error: " + data));
                            });
                            instance.on('close', function (code) {
                                if (code != 0) {
                                    reject(new Error("Process exited with code " + code));
                                    return;
                                }
                                resolve();
                            });
                        })];
                    case 9:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    RegistryManager.prototype[Symbol.asyncIterator] = function () {
        var _a;
        var _this = this;
        return _a = {
                next: function () { return __awaiter(_this, void 0, void 0, function () {
                    var queries, index, data, _a, _b;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0:
                                queries = [];
                                for (index = 0; index < this.threads; index += 1) {
                                    if (!this.loader.hasNext()) {
                                        break;
                                    }
                                    queries.push(this.loader.next());
                                }
                                _b = (_a = _).flatten;
                                return [4 /*yield*/, Promise.all(queries)];
                            case 1:
                                data = _b.apply(_a, [_c.sent()]);
                                if (typeof this.loader.total === 'number') {
                                    this.total = this.loader.total;
                                }
                                this.done = this.loader.done;
                                this.updateNote();
                                return [2 /*return*/, {
                                        value: data,
                                        done: !this.loader.hasNext()
                                    }];
                        }
                    });
                }); }
            },
            _a[Symbol.asyncIterator] = this,
            _a;
    };
    return RegistryManager;
}());
exports.RegistryManager = RegistryManager;
var PackageSingleLoader = /** @class */ (function () {
    function PackageSingleLoader() {
        this.name = 'Package-strategy loader';
        this.total = packages.length;
        this.done = 0;
        this.errors = 0;
        this.packages = packages;
        this.updateNote();
    }
    PackageSingleLoader.prototype.updateNote = function () {
        this.note = logging_1.toTerminalString(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      This loader query packages one by one (instead of bulk loading), therefore you \n      will receive all packages. It =produce huge load on NPM servers and your network \n      connection (possibly). Use it at your own risk (you can be banned, for example).\n      \n      Loader errors count (package not found, network issues, etc): ", "\n    "], ["\n      This loader query packages one by one (instead of bulk loading), therefore you \n      will receive all packages. It =produce huge load on NPM servers and your network \n      connection (possibly). Use it at your own risk (you can be banned, for example).\n      \n      Loader errors count (package not found, network issues, etc): ", "\n    "])), this.errors);
    };
    PackageSingleLoader.prototype.next = function () {
        return __awaiter(this, void 0, void 0, function () {
            var next, response, _a, _b, error_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        next = this.packages.splice(-1);
                        if (!next) {
                            throw new Error("There is no packages to load anymore, internal error (this is exceptional case)");
                        }
                        response = [];
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        _b = (_a = response).push;
                        return [4 /*yield*/, networking_1.request("http://registry.npmjs.org/" + next)];
                    case 2:
                        _b.apply(_a, [_c.sent()]);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _c.sent();
                        this.errors += 1;
                        this.updateNote();
                        return [3 /*break*/, 4];
                    case 4:
                        this.done += 1;
                        return [2 /*return*/, response];
                }
            });
        });
    };
    PackageSingleLoader.prototype.hasNext = function () {
        return this.packages.length > 0;
    };
    return PackageSingleLoader;
}());
var PackageSearchingLoader = /** @class */ (function () {
    function PackageSearchingLoader() {
        this.name = 'Search-strategy loader';
        this.note = '';
        this.found = 0;
        this.limit = 200;
        this.groups = _.groupBy(packages, function (data) { return data.slice(0, 2); });
        this.total = Object.keys(this.groups).length;
        this.done = 0;
        this.memory = [];
    }
    PackageSearchingLoader.prototype.updateNote = function (query) {
        this.note = logging_1.toTerminalString(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n      This loader is searching for packages meta using NPM search api, therefore it\n      is so fast (it may take about 5-40 min to retrieve meta-data for all packages \n      depends on your internet connection and hardware), but does not have all packages (NPM \n      issue, this API has about 2-7 times less packages available to public). If you want to \n      load all packages, use option --npm-force-package-api to load them one by one. Do it at \n      your own risk, it will produce huge load on NPM servers, your internet connection, and your \n      filesystem (in case if of downloading some huge amount of data).\n    \n      Current query: ", "\n      Currently found packages (not unique list, just search results total count): ", "\n    "], ["\n      This loader is searching for packages meta using NPM search api, therefore it\n      is so fast (it may take about 5-40 min to retrieve meta-data for all packages \n      depends on your internet connection and hardware), but does not have all packages (NPM \n      issue, this API has about 2-7 times less packages available to public). If you want to \n      load all packages, use option --npm-force-package-api to load them one by one. Do it at \n      your own risk, it will produce huge load on NPM servers, your internet connection, and your \n      filesystem (in case if of downloading some huge amount of data).\n    \n      Current query: ", "\n      Currently found packages (not unique list, just search results total count): ", "\n    "])), JSON.stringify(query), this.found);
    };
    PackageSearchingLoader.prototype.next = function () {
        return __awaiter(this, void 0, void 0, function () {
            var query, response, foundPackages, newPackages, error_2;
            var _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        query = this.getSearchQuery();
                        if (!query) {
                            throw new Error("Query is empty, cannot load next data, internal error");
                        }
                        return [4 /*yield*/, networking_1.request("http://registry.npmjs.org/-/v1/search?text=" + query.group + "&from=" + query.offset + "&size=" + query.limit)];
                    case 1:
                        response = (_b.sent());
                        foundPackages = response.objects.map(function (data) { return data.package; });
                        newPackages = foundPackages.filter(function (meta) { return !_this.memory.includes(meta.name); });
                        (_a = this.memory).push.apply(_a, __spread(newPackages.map(function (meta) { return meta.name; })));
                        this.found += foundPackages.length;
                        this.done = this.total - Object.keys(this.groups).length;
                        this.updateNote(query);
                        return [2 /*return*/, newPackages];
                    case 2:
                        error_2 = _b.sent();
                        throw new Error("Cannot load data from the server, error: " + error_2.message);
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    PackageSearchingLoader.prototype.hasNext = function () {
        return Object.keys(this.groups).length > 0;
    };
    PackageSearchingLoader.prototype.getSearchQuery = function () {
        var group;
        var name;
        for (var groupName in this.groups) {
            var current = this.groups[groupName];
            if (current.length === 0) {
                continue;
            }
            group = current;
            name = groupName;
            break;
        }
        if (!group) {
            return null;
        }
        group.splice(-this.limit);
        if (group.length === 0) {
            delete this.groups[name];
        }
        return {
            group: name,
            offset: group.length,
            limit: this.limit
        };
    };
    return PackageSearchingLoader;
}());
var templateObject_1, templateObject_2, templateObject_3;
